SystemOrganization addCategory: #'Mondrian-Layouts'!
SystemOrganization addCategory: #'Mondrian-Layouts-Tests'!

MOLayout subclass: #MOAbstractFlowLayout
	instanceVariableNames: 'maxWidth gapSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractFlowLayout classSide methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withMaxWidth: anInteger
	
	^(self new)
		maxWidth: anInteger;
		yourself! !

!MOAbstractFlowLayout classSide methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withMaxWidth: anInteger withGap: anotherInteger
	
	^(self new)
		maxWidth: anInteger;
		gapSize: anotherInteger;
		yourself! !

!MOAbstractFlowLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
gapSize
	
	^gapSize! !

!MOAbstractFlowLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
gapSize: anObject
	
	gapSize := anObject! !

!MOAbstractFlowLayout methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 4/2/2009 00:41'!
initialize
	
	super initialize.
	maxWidth := 100.
	gapSize := 5! !

!MOAbstractFlowLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
maxWidth
	
	^maxWidth! !

!MOAbstractFlowLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
maxWidth: anObject
	
	maxWidth := anObject! !

MOAbstractFlowLayout subclass: #MOBottomFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOBottomFlowLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:08'!
doExecute: aGraph 
	| x y maxLastLineHeight lineHeights lineNumber |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	lineHeights := OrderedCollection new.
	lineNumber := 1.
	aGraph nodes do: 
		[ :aNodeFigure | 
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ lineHeights addLast: maxLastLineHeight.
			x := self gapSize.
			maxLastLineHeight := 0 ] ].
	lineHeights addLast: maxLastLineHeight.
	x := self gapSize.
	aGraph nodes do: 
		[ :aNodeFigure | 
		| lineHeight |
		lineHeight := lineHeights at: lineNumber.
		aNodeFigure translateTo: x @ (y + lineHeight - aNodeFigure height).
		x := x + aNodeFigure width + (2 * self gapSize).
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + lineHeight.
			lineNumber := lineNumber + 1 ] ]! !

MOAbstractFlowLayout subclass: #MOFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOFlowLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:08'!
doExecute: aGraph 
	| x y maxLastLineHeight |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	aGraph nodes do: 
		[ :aNodeFigure | 
		aNodeFigure translateTo: x @ y.
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + maxLastLineHeight.
			maxLastLineHeight := 0 ] ]! !

MOLayout subclass: #MOAbstractGraphLayout
	instanceVariableNames: 'verticalGap horizontalGap cachedChildren cachedParents cachedParentsWithHighestNestings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractGraphLayout classSide methodsFor: 'constants' stamp: ' 24/4/08 15:59'!
horizontalGap
	
	^3.0! !

!MOAbstractGraphLayout classSide methodsFor: 'constants' stamp: ' 24/4/08 15:59'!
verticalGap
	
	^20.0! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
cachedChildren
	
	cachedChildren ifNil: [cachedChildren := IdentityDictionary new: 1000].
	^cachedChildren! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
cachedParents
	
	cachedParents ifNil: [cachedParents := IdentityDictionary new: 1000].
	^cachedParents! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
cachedParentsWithHighestNestings
	
	cachedParentsWithHighestNestings
		ifNil: [cachedParentsWithHighestNestings := IdentityDictionary new: 1000].
	^cachedParentsWithHighestNestings! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'AlexandreBergel 12/30/2010 13:07'!
childrenFor: aNode
	
	^self cachedChildren
		at: aNode
		ifAbsentPut:
			[| nodes |
			nodes := OrderedCollection new.
			self edgesDo:
					[:edge | 
					(edge source == aNode and: [edge target ~= aNode])
						ifTrue:
							[(nodes includes: edge target) ifFalse: [nodes add: edge target]]].
			nodes]! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'TudorGirba 5/16/2012 20:41'!
childrenFor: aNode except: aNodeCollection
	
	^(self childrenFor: aNode) 
		reject: [:each | aNodeCollection includes: each]
	
	"we are explicitly not using the default Collection>>difference: behavior here because we want to preserve the order of the collection"! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
childrenWithHighestNestingLevelFor: aNode
	
	^(self childrenFor: aNode)
		select: [:eachChild | (self highestNestingParentFor: eachChild) == aNode]! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'Alexandre.Bergel 3/26/2009 10:59'!
clear
	
	cachedParents := nil.
	cachedChildren := nil.
	cachedParentsWithHighestNestings := nil! !

!MOAbstractGraphLayout methodsFor: 'default values' stamp: ' 24/4/08 15:59'!
defaultFromPositions
	
	^#(#bottomCenter)! !

!MOAbstractGraphLayout methodsFor: 'default values' stamp: ' 24/4/08 15:59'!
defaultToPositions
	
	^#(#topCenter)! !

!MOAbstractGraphLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:08'!
doInitialize: aGraph 
	super doInitialize: aGraph.
	self clear.
	self greedyCycleRemoval: aGraph nodes! !

!MOAbstractGraphLayout methodsFor: 'battista' stamp: 'tg 4/24/2008 16:14'!
greedyCycleRemoval: aCollection
	"Di Battista Greedy-Cycle-Removal algorithm. Chapter 9.4, page 297. The last part is not like in the book. The original algorithm only takes
	 local optimas into account. This will break ordinary trees sometimes. This version also takes global optimas into account."
	
	| g sl sr s indeg outdeg degrees vertex |
	g := aCollection copy.
	sl := OrderedCollection new.
	sr := OrderedCollection new.	"While g contains a sink (aka leaf)"
	g copy
		do:
			[:node | 
			(self childrenFor: node) isEmpty
				ifTrue:
					[sr addFirst: node.
					g remove: node]	"self edges detect: [:edge | edge fromFigure == node] ifNone: [sr addFirst: node. g remove: node]"].	"While g contains a source (aka root)"
	g copy
		do:
			[:node | 
			(self parentsFor: node) isEmpty
				ifTrue:
					[sl addLast: node.
					g remove: node]	"self edges detect: [:edge | edge toFigure == node] ifNone: [sl addLast: node. g remove: node]"].	"Calculate deg for all remaining vertices"
	degrees := IdentityDictionary new.
	g
		do:
			[:node | 
			indeg := (self parentsFor: node) size.
			outdeg := (self childrenFor: node) size.	"indeg := self edges inject: 0 into: [:sum :edge | (edge toFigure == node) ifTrue: [sum + 1] ifFalse: [sum]].
		outdeg := self edges inject: 0 into: [:sum :edge | (edge fromFigure == node) ifTrue: [sum + 1] ifFalse: [sum]]."
			degrees
				at: node
				put: outdeg - indeg].	"While g not empty"
	g := g asSortedCollection: [:a :b | (degrees at: a) >= (degrees at: b)].
	[g isEmpty]
		whileFalse:
			[vertex := g
				detect: [:v | (self parentsFor: v) anySatisfy: [:w | sl includes: w]]
				ifNone: [g first].	"Corner case: Closed cycle with not root at all. Eg 1 -> 2 -> 3 -> 1"
			sl addLast: vertex.
			g remove: vertex].	"Remove all leftward edges"
	s := sl , sr.
	self edges copy
		do:
			[:edge | 
			(s indexOf: edge source) > (s indexOf: edge target)
				ifTrue: [self edges remove: edge]].	"Reset the cache"
	self clear! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
highestNestingParentFor: aNodeFigure
	
	| parents |
	^self cachedParentsWithHighestNestings
		at: aNodeFigure
		ifAbsentPut:
			[parents := self parentsFor: aNodeFigure.
			parents isEmpty
				ifTrue: [0]
				ifFalse:
					[parents detectMax: [:eachParent | self nestingLevelFor: eachParent]]]! !

!MOAbstractGraphLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalGap
	
	^horizontalGap ifNil: [self class horizontalGap]! !

!MOAbstractGraphLayout methodsFor: 'accessing' stamp: 'simon.denier 3/5/2009 11:57'!
horizontalGap: anInteger
	
	horizontalGap := anInteger! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'simon.denier 3/5/2009 16:37'!
nestingLevelFor: aNodeFigure
	
	| parents parentsNesting |
	parents := self parentsFor: aNodeFigure.
	parentsNesting := parents
		collect: [:eachParent | self nestingLevelFor: eachParent].
	^parentsNesting isEmpty
		ifTrue: [0]
		ifFalse: [parentsNesting max + 1]
! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'AlexandreBergel 12/30/2010 13:07'!
parentsFor: aNode
	"MOGraphElement knows its outgoing edges, getting the parent of a node should be faster than this method"
	^ self cachedParents
		at: aNode
		ifAbsentPut:
			[ | nodes |
			nodes := OrderedCollection new.
			self edgesDo:
					[:edge | edge target == aNode ifTrue: [ nodes add: edge source ] ].
			nodes ]! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'Alexandre.Bergel 8/30/2009 15:42'!
rootNodesFor: aCollection
	^ aCollection select: [:node | (self parentsFor: node) isEmpty ].
	
	"| nodes |
	nodes := OrderedCollection new.
	aCollection
		do:
			[:node | (self parentsFor: node) isEmpty ifTrue: [nodes add: node]].
	^nodes"! !

!MOAbstractGraphLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalGap
	
	^verticalGap ifNil: [self class verticalGap]! !

!MOAbstractGraphLayout methodsFor: 'accessing' stamp: 'simon.denier 3/5/2009 11:57'!
verticalGap: anInteger
	
	verticalGap := anInteger! !

MOAbstractGraphLayout subclass: #MOAbstractRegularTreeLayout
	instanceVariableNames: 'alreadyLayoutedNodes topGap leftGap nodesByLayer isLayered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

MOAbstractRegularTreeLayout subclass: #MOAbstractHorizontalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/15/2010 00:47'!
computeChildrenFor: aNode
	self subclassResponsibility! !

!MOAbstractHorizontalTreeLayout methodsFor: 'default values' stamp: 'tg 8/14/2010 22:50'!
defaultFromPositions
	
	^#(#rightCenter)! !

!MOAbstractHorizontalTreeLayout methodsFor: 'default values' stamp: 'tg 8/14/2010 22:50'!
defaultToPositions
	
	^#(#leftCenter)! !

!MOAbstractHorizontalTreeLayout methodsFor: 'initialize-release' stamp: 'tg 8/14/2010 23:04'!
initialize
	super initialize.
	verticalGap := 3.
	horizontalGap := 20! !

!MOAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 23:03'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y middleOfTree |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenPosition := x + each width + self horizontalGap.
		treeSize := each height
			max: (self layout: (self computeChildrenFor: each) atPoint: childrenPosition @ y atLayer: aNumber + 1).
		middleOfTree := y + (treeSize / 2.0) - (each height / 2.0).
		each translateTo: x @ middleOfTree.
		y := y + treeSize + self verticalGap ].
	^ y - aPoint y - self verticalGap! !

!MOAbstractHorizontalTreeLayout methodsFor: 'private' stamp: 'tg 8/15/2010 00:38'!
rearrangeByLayers: aGraph
	| cursor layerDepthSize |
	cursor := self leftGap.
	nodesByLayer do: [:eachSetOfNodes |
		layerDepthSize := eachSetOfNodes inject: 0 into: [:max :eachNode | 
			eachNode translateTo: (cursor @ eachNode absoluteBounds top).
			max max: eachNode width ].
		cursor := cursor + layerDepthSize + self horizontalGap ]! !

MOAbstractHorizontalTreeLayout subclass: #MOBulletTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOBulletTreeLayout methodsFor: 'hook-private' stamp: 'AlexandreBergel 8/31/2010 18:03'!
computeChildrenFor: aNode! !

!MOBulletTreeLayout methodsFor: 'default values' stamp: 'AlexandreBergel 12/29/2010 18:38'!
defaultFromPositions
	
	^#(#bottomLeft)! !

!MOBulletTreeLayout methodsFor: 'default values' stamp: 'AlexandreBergel 12/29/2010 18:38'!
defaultToPositions
	
	^#(#leftCenter)! !

!MOBulletTreeLayout methodsFor: 'initialize-release' stamp: 'tg 8/15/2010 00:45'!
initialize
	
	super initialize.
	verticalGap := 3.
	horizontalGap := 10! !

!MOBulletTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/15/2010 00:45'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeHeight childrenX x y |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenX := x + self horizontalGap.
		y := y + each height.
		treeHeight := self
			layout: (self childrenFor: each)
			atPoint: childrenX @ y
			atLayer: aNumber + 1.
		each translateTo: x @ y.
		y := y + treeHeight + self verticalGap ].
	^ y - aPoint y - self verticalGap! !

MOAbstractHorizontalTreeLayout subclass: #MOHorizontalDominanceTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalDominanceTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:51'!
computeChildrenFor: aNode
	^ self childrenWithHighestNestingLevelFor: aNode! !

MOHorizontalDominanceTreeLayout subclass: #MOHorizontalDominanceTreeWithTimelineLayout
	instanceVariableNames: 'timeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalDominanceTreeWithTimelineLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 11/16/2011 13:50'!
doExecute: aGraph
	super doExecute: aGraph.
	aGraph nodes do: [ :aNodeElement | 
			aNodeElement translateBy: 
				(timeBlock moValue: aNodeElement model) @ (0) ]! !

!MOHorizontalDominanceTreeWithTimelineLayout methodsFor: 'accessing' stamp: 'MirceaLungu 8/18/2010 21:26'!
timeBlock
	^ timeBlock! !

!MOHorizontalDominanceTreeWithTimelineLayout methodsFor: 'accessing' stamp: 'MirceaLungu 8/18/2010 21:26'!
timeBlock: anObject
	timeBlock := anObject! !

MOAbstractHorizontalTreeLayout subclass: #MOHorizontalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:51'!
computeChildrenFor: aNode
	^ self childrenFor: aNode except: alreadyLayoutedNodes! !

!MOAbstractRegularTreeLayout methodsFor: 'private' stamp: 'tg 2/12/2010 15:31'!
atLayer: aNumber add: aNodeCollection
	| collection |
	collection := nodesByLayer at: aNumber ifAbsentPut: [OrderedCollection new].
	collection addAll: aNodeCollection! !

!MOAbstractRegularTreeLayout methodsFor: 'hook' stamp: 'AlexandreBergel 12/29/2010 18:30'!
doExecute: node
	| rootNodes |
	alreadyLayoutedNodes := OrderedCollection new.
	rootNodes := self rootNodesFor: node nodes.
	nodesByLayer := OrderedCollection new.
	self
		layout: rootNodes
		atPoint: self leftGap @ self topGap
		atLayer: 1.
	self isLayered ifTrue: [
		self rearrangeByLayers: node ]! !

!MOAbstractRegularTreeLayout methodsFor: 'initialize-release' stamp: 'tg 8/16/2010 16:58'!
initialize
	super initialize.
	topGap := 5.
	leftGap := 5.
	isLayered := false! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2010 21:30'!
isLayered
	"Is the layout layered"
	
	^ isLayered! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2010 21:30'!
isLayered: boolean
	"Is the layout layered"
	
	isLayered := boolean! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 8/16/2010 16:58'!
layered
	self isLayered: true! !

!MOAbstractRegularTreeLayout methodsFor: 'hook-private' stamp: 'tg 2/12/2010 07:45'!
layout: aNodeCollection atPoint: aPoint atLayer: anObject
	self subclassResponsibility! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 1/20/2010 02:59'!
leftGap
	^ leftGap! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/17/2011 11:48'!
leftGap: anInteger
	leftGap := anInteger! !

!MOAbstractRegularTreeLayout methodsFor: 'private' stamp: 'tg 8/14/2010 23:14'!
rearrangeByLayers: aGraph
	self subclassResponsibility! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 1/20/2010 02:58'!
topGap
	^ topGap! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/17/2011 11:48'!
topGap: anInteger
	topGap := anInteger! !

MOAbstractRegularTreeLayout subclass: #MOAbstractVerticalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:39'!
computeChildrenFor: aNode
	self subclassResponsibility! !

!MOAbstractVerticalTreeLayout methodsFor: 'initialize-release' stamp: 'tg 8/14/2010 23:04'!
initialize
	super initialize.
	verticalGap := 20.
	horizontalGap := 3! !

!MOAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 23:03'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y middleOfTree |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenPosition := y + each height + self verticalGap.
		treeSize := each width
			max: (self layout: (self computeChildrenFor: each) atPoint: x @ childrenPosition atLayer: aNumber + 1).
		middleOfTree := x + (treeSize / 2.0) - (each width / 2.0).
		each translateTo: middleOfTree @ y.
		x := x + treeSize + self horizontalGap ].
	^ x - aPoint x - self horizontalGap! !

!MOAbstractVerticalTreeLayout methodsFor: 'private' stamp: 'tg 8/15/2010 00:38'!
rearrangeByLayers: aGraph
	| cursor layerDepthSize |
	cursor := self topGap.
	nodesByLayer do: [:eachSetOfNodes |
		layerDepthSize := eachSetOfNodes inject: 0 into: [:max :eachNode | 
			eachNode translateTo: (eachNode absoluteBounds left @ cursor ).
			max max: eachNode height ].
		cursor := cursor + layerDepthSize + self verticalGap ]! !

MOAbstractVerticalTreeLayout subclass: #MODominanceTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MODominanceTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:40'!
computeChildrenFor: aNode
	^ self childrenWithHighestNestingLevelFor: aNode! !

MOAbstractVerticalTreeLayout subclass: #MOTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:40'!
computeChildrenFor: aNode
	^ self childrenFor: aNode except: alreadyLayoutedNodes! !

!MOTreeLayout methodsFor: 'default' stamp: 'AlexandreBergel 12/29/2010 18:27'!
defaultFromPositions
	^ #(#bottomCenter)! !

!MOTreeLayout methodsFor: 'default' stamp: 'AlexandreBergel 12/29/2010 18:26'!
defaultToPositions
	^ #(#topCenter)! !

MOAbstractGraphLayout subclass: #MONarrowTreeLayout
	instanceVariableNames: 'layers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MONarrowTreeLayout commentStamp: '<historical>' prior: 0!
Classical Code Crawler vertical tree layout.

Instance Variables:
	layers	<Dictionary>	Contains a TreeLayerWrapper for every layer

!

MONarrowTreeLayout subclass: #MOHorizontalNarrowTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalNarrowTreeLayout methodsFor: 'default values' stamp: 'tg 7/25/2010 14:40'!
defaultFromPositions
	
	^#(#rightCenter)! !

!MOHorizontalNarrowTreeLayout methodsFor: 'default values' stamp: 'tg 7/25/2010 14:40'!
defaultToPositions
	
	^#(#leftCenter)! !

!MOHorizontalNarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:30'!
shapeTree: aRoot position: xOffset
	
	| treeHeight layerKeys layer layerHeight horizontalPosition verticalPosition |
	self buildLayers: aRoot.
	treeHeight := self currentTreeSize.
	horizontalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection.
	layerKeys do: [:aKey | 
		layer := layers at: aKey.
		layerHeight := layer width: self horizontalGap.
		verticalPosition := treeHeight / 2.0 + xOffset - (layerHeight / 2.0).
		layer do: [:aFigure | 
			aFigure translateTo: horizontalPosition @ verticalPosition.
			verticalPosition := verticalPosition + aFigure width + self horizontalGap].
		horizontalPosition := horizontalPosition + layer height + self verticalGap].
	^treeHeight! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:15'!
atLayer: aLayer add: aFigure
	"Associates the figure aFigure with the layer aLayer"
	
	| layer |
	layer := layers
		at: aLayer
		ifAbsent:
			[layers
				at: aLayer
				put: MOTreeLayerWrapper new.
			layers at: aLayer].
	layer add: aFigure! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:20'!
buildLayers: aRoot
	layers := Dictionary new.
	self buildLayers: aRoot layer: 0! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:20'!
buildLayers: aRoot layer: aLayer
	self atLayer: aLayer add: aRoot.
	(self childrenFor: aRoot) do: [:aChild | 
		self
			buildLayers: aChild
			layer: aLayer + 1 ]! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:31'!
currentTreeSize
	| maximum |
	maximum := 0.
	layers values do: [:aLayer | 
		maximum := maximum max: (aLayer width: self horizontalGap)].
	^maximum! !

!MONarrowTreeLayout methodsFor: 'hook' stamp: 'tg 7/25/2010 14:18'!
doExecute: aGraph 
	| roots offset treeWidth |
	roots := self rootNodesFor: aGraph nodes.
	offset := self horizontalGap.
	roots do: 
		[ :aRoot | 
		treeWidth := self 
			shapeTree: aRoot
			position: offset.
		offset := offset + treeWidth + (2 * self horizontalGap) ]! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:29'!
shapeTree: aRoot position: xOffset
	self subclassResponsibility! !

MONarrowTreeLayout subclass: #MOVerticalNarrowTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOVerticalNarrowTreeLayout commentStamp: '<historical>' prior: 0!
Classical Code Crawler vertical tree layout.

Instance Variables:
	layers	<Dictionary>	Contains a TreeLayerWrapper for every layer

!

!MOVerticalNarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:22'!
shapeTree: aRoot position: xOffset
	
	| treeWidth layerKeys layer layerWidth horizontalPosition verticalPosition |
	self buildLayers: aRoot.
	treeWidth := self currentTreeSize.
	verticalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection.
	layerKeys do: [:aKey | 
		layer := layers at: aKey.
		layerWidth := layer width: self horizontalGap.
		horizontalPosition := treeWidth / 2.0 + xOffset - (layerWidth / 2.0).
		layer do: [:aFigure | 
			aFigure translateTo: horizontalPosition @ verticalPosition.
			horizontalPosition := horizontalPosition + aFigure width + self horizontalGap].
		verticalPosition := verticalPosition + layer height + self verticalGap].
	^treeWidth! !

MOAbstractGraphLayout subclass: #MORadialTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MORadialTreeLayout methodsFor: 'hook' stamp: 'AlexandreBergel 9/6/2010 11:21'!
doExecute: aGraph 
	"	| rootNodes top left |
	top := left := Unlimited positive.
	rootNodes := self rootNodesFor: aGraph nodeFigures.
	self layoutLayer: rootNodes radius: 5 from: 0 to: (2 * Double pi).
	aGraph nodeFigures do: [:each | 
		top := top min: each bounds top. 
		left := left min: each bounds left.].
	aGraph nodeFigures do: [:each | 
		each translateBy: ((0 - left)) @ ((0 - top)).
	].


"
	| rootNodes maximumRadius xOffset |

	rootNodes := self rootNodesFor: aGraph nodes.
	xOffset := 0.
	rootNodes do: 
		[ :node | 
		node translateTo: 0 @ 0.	"Move the node to the origin of the coordinate system"
		maximumRadius := self 
			layoutLayer: (self childrenFor: node)
			radius: node radius
			from: 0
			to: 2 * Float pi.
		self 
			shiftTree: node
			by: (maximumRadius + xOffset) @ maximumRadius.
		xOffset := xOffset + (2 * maximumRadius) ]! !

!MORadialTreeLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
gap
	
	^self verticalGap! !

!MORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 9/6/2010 11:21'!
layoutLayer: aCollection radius: oldRadius from: aFromAngle to: aToAngle
	
	| delta childRadius maximumRadius myRadius fromAngle toAngle |
	"Initialize with default value"
	maximumRadius := oldRadius.
	aCollection isEmpty
		ifFalse:
			[myRadius := oldRadius + self gap + (self maximumRadius: aCollection).
			childRadius := oldRadius + self gap + (self maximumDiameter: aCollection).	"This is a purely optical tweak"
			(aCollection size = 1 and: [aToAngle - aFromAngle = (2 * Float pi)])
				ifTrue:
					[delta := 0.4 * Float pi.
					fromAngle := 0.8 * Float pi.
					toAngle := fromAngle + delta]
				ifFalse:
					[delta := (aToAngle - aFromAngle) / aCollection size.
					fromAngle := aFromAngle.
					toAngle := aFromAngle + delta].
			aCollection
				do:
					[:child | 
					child
						translateTo:
							(Point
								r: myRadius
								theta: toAngle - (delta / 2.0)).
					maximumRadius := maximumRadius
						max:
							(self
								layoutLayer: (self childrenFor: child)
								radius: childRadius
								from: fromAngle
								to: toAngle).
					fromAngle := toAngle.
					toAngle := toAngle + delta]].
	^maximumRadius! !

!MORadialTreeLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
maximumDiameter: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: node diameter]! !

!MORadialTreeLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
maximumRadius: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: node radius]! !

!MORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 2/12/2009 10:31'!
shiftTree: aNode by: aPoint
	
	aNode translateBy: aPoint.
	(self childrenFor: aNode) do: [:child | self shiftTree: child by: aPoint]! !

MOAbstractGraphLayout subclass: #MOSugiyamaLayout
	instanceVariableNames: 'sortBlock labels layers layerNrs connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOSugiyamaLayout classSide methodsFor: 'utils' stamp: ' 24/4/08 15:59'!
sortBlock
	
	^MOSortBlock new! !

!MOSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 12/30/2010 13:11'!
addDummyNodes
	
	| layer layerNr |
	connections := MOIdentityMatrix new.
	self edgesDo:
			[:edge | 
			| a b span fromNode toNode |
			"edge hints removeAll."
			a := layerNrs at: edge source.
			b := layerNrs at: edge target.
			span := (a - b) abs.
			span = 1
				ifTrue:
					[connections
						at: edge source
						at: edge target
						put: true].	"Normal case where nodes are in adjacent layers"
			fromNode := edge source.
			[span > 1]
				whileTrue:
					[span := span - 1.
					layerNr := b + span.
					layer := layers at: layerNr.
					toNode := MODummyNode
						on: edge
						slot: a - span.
					layer add: toNode.
					layerNrs at: toNode put: layerNr.
					connections at: fromNode at: toNode put: true.
					fromNode := toNode].
			(a - b) abs > 1
				ifTrue:
					[connections
						at: fromNode
						at: edge target
						put: true]]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: 'simon.denier 4/30/2009 13:24'!
assignLabels: aGraph 
	"Initialize label dictionary"
	| label vertices parentLabels |
	labels := IdentityDictionary new.
	label := 1.	"Assign labels to the roots"
	(self rootNodesFor: aGraph nodes) do: 
		[ :node | 
		labels 
			at: node
			put: label.
		label := label + 1 ].	"Assign labels to the rest"
	[ labels keys size < aGraph nodes size ] whileTrue: 
		[ vertices := SortedCollection sortBlock: self sortBlock.
		aGraph nodes do: 
			[ :node | 
			(labels includesKey: node) ifFalse: 
				[ parentLabels := ((self parentsFor: node) collect: 
					[ :pn | 
					labels 
						at: pn
						ifAbsent: [ Float infinity ] ]) asSortedCollection.
				parentLabels last ~= Float infinity ifTrue: [ vertices add: node -> parentLabels ] ] ].
		labels 
			at: vertices first key
			put: label.
		label := label + 1 ]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: 'simon.denier 4/30/2009 13:26'!
buildLayers: g
	
	| w layerNr u vertices vertex layer done |
	w := Float infinity.
	u := OrderedCollection new.
	layers := IdentityDictionary new.
	layerNrs := IdentityDictionary new.	"Assign all nodes to layers"
	[g isEmpty]
		whileFalse:
			[vertices := g
				select:
					[:e | (self childrenFor: e) allSatisfy: [:node | u includes: node]].
			vertex := vertices detectMax: [:e | labels at: e].
			done := false.
			layerNr := 1.
			[done]
				whileFalse:
					[layer := layers
						at: layerNr
						ifAbsentPut: [OrderedCollection new].
					(layer size >= w
						or:
							[(self childrenFor: vertex) anySatisfy: [:n | (layerNrs at: n) >= layerNr]])
						ifTrue: [layerNr := layerNr + 1]
						ifFalse: [done := true]].
			layer add: vertex.
			layerNrs at: vertex put: layerNr.
			u add: vertex.
			g remove: vertex]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
cl: layer u: u v: v
	"Calculates cuv. Di Battista, chapter 9.2.2, page 283"
	
	| partnersOfU partnersOfV c partnersOfUIndex partnersOfVIndex layerNr |
	layerNr := layerNrs at: u.	":= layerNrs at: v"
	partnersOfU := (connections at: u)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	partnersOfV := (connections at: v)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	c := 0.
	partnersOfUIndex := partnersOfU collect: [:node | layer indexOf: node].
	partnersOfVIndex := partnersOfV collect: [:node | layer indexOf: node].
	partnersOfUIndex
		do:
			[:uIndex | partnersOfVIndex do: [:vIndex | vIndex < uIndex ifTrue: [c := c + 1]]].
	^c! !

!MOSugiyamaLayout methodsFor: 'hook' stamp: 'AlexandreBergel 12/29/2010 19:09'!
doExecute: node 
	"Coffman-Graham-Layering. Di Battista Book, page 275, chapter, 9.2.1"
	self assignLabels: node.
	self buildLayers: node nodes copy.
	self addDummyNodes.
	self reduceCrossing.
	self layoutAt: self verticalGap @ self horizontalGap! !

!MOSugiyamaLayout methodsFor: 'private' stamp: 'Alexandre Bergel 7/26/2010 14:59'!
layoutAt: aPoint
	
	| treeWidth layerKeys layer layerWidth horizontalPosition verticalPosition layerHeight |
	treeWidth := layers values
		inject: Float infinity negated
		into:
			[:max :e | max max: (e sum: #width) + ((e size - 1) * self horizontalGap)].
	verticalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection reverse.
	layerKeys
		do:
			[:aKey | 
			layer := layers at: aKey.
			layerWidth := (layer sum: #width)
				+ ((layer size - 1) * self horizontalGap).
			layerHeight := (layer detectMax: #height) height.
			horizontalPosition := treeWidth / 2.0 + aPoint x - (layerWidth / 2.0).
			layer
				do:
					[:node | 
					node translateTo: horizontalPosition @ verticalPosition.
					horizontalPosition := horizontalPosition + node width
						+ self horizontalGap].
			verticalPosition := verticalPosition + layerHeight + self verticalGap]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
reduceCrossing
	"Crossing reduction"
	
	| layer2 u v c1 c2 layer1 done |
	2
		to: layers keys size
		do:
			[:index | 
			layer1 := layers at: index - 1.
			layer2 := layers at: index.
			done := false.
			[done]
				whileFalse:
					[done := true.
					2
						to: layer2 size
						do:
							[:i | 
							u := layer2 at: i - 1.
							v := layer2 at: i.
							c1 := self cl: layer1 u: u v: v.
							c2 := self cl: layer1 u: v v: u.
							c1 > c2
								ifTrue:
									[layer2 swapElement: u withElement: v.
									done := false]]]]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
sortBlock
	
	sortBlock isNil ifTrue: [sortBlock := self class sortBlock].
	^sortBlock! !

MOAbstractGraphLayout subclass: #MOTreeMapLayout
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOTreeMapLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
deepCountChildrenFor: aNode
	
	| children |
	children := 0.
	(self childrenFor: aNode)
		do:
			[:child | children := children + 1 + (self deepCountChildrenFor: child)].
	^children! !

!MOTreeMapLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:08'!
doExecute: aGraph 
	| offset |
	graph := aGraph.
	self hideEdges.
	offset := self horizontalGap.
	(self rootNodesFor: aGraph nodes) do: 
		[ :aRoot | 
		self 
			verticalLayout: aRoot
			at: offset @ 5
			width: aRoot width
			height: aRoot height.
		offset := offset + aRoot width + self horizontalGap ]! !

!MOTreeMapLayout methodsFor: 'private' stamp: 'AlexandreBergel 12/30/2010 13:11'!
hideEdges
	graph edgesDo: [ :edge | edge isVisible: false ]! !

!MOTreeMapLayout methodsFor: 'private' stamp: 'AlexandreBergel 11/16/2011 09:50'!
horizontalLayout: node at: aPosition width: width height: aHeight
	
	| numberOfChildren position |
	node translateTo: aPosition.
"	node width: width.
	node height: aHeight.
	self bringToFront: node.
"
	node copyShapeAndDo: [:shape | shape width: width; height: aHeight].
	
	numberOfChildren := self deepCountChildrenFor: node.
	position := aPosition.
	(self childrenFor: node)
		do:
			[:child | 
			| height |
			height := (1 + (self deepCountChildrenFor: child)) * aHeight /
					numberOfChildren.
			self verticalLayout: child at: position asIntegerPoint width: width asInteger height: height asInteger.
			position := position + (0 @ height)]! !

!MOTreeMapLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	
	super initialize.
	horizontalGap := 10! !

!MOTreeMapLayout methodsFor: 'private' stamp: 'AlexandreBergel 11/16/2011 09:50'!
verticalLayout: node at: aPosition width: aWidth height: height
	
	| numberOfChildren position |
	node translateTo: aPosition.
	node copyShapeAndDo: [:shape | shape width: aWidth; height: height].
	
	numberOfChildren := self deepCountChildrenFor: node.
	position := aPosition.
	(self childrenFor: node)
		do:
			[:child | 
			| width |
			width := (1 + (self deepCountChildrenFor: child)) * aWidth /
					numberOfChildren.
			self horizontalLayout: child at: position asIntegerPoint width: width asInteger height: height asInteger.
			position := position + (width @ 0)]! !

MOLayout subclass: #MOAbstractLineLayout
	instanceVariableNames: 'gapSize horizontalGap verticalGap horizontalOutGap verticalOutGap alignment horizontallyStretchable verticallyStretchable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractLineLayout classSide methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withGap: anInteger
	
	^(self new)
		gapSize: anInteger;
		yourself! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignBottom
	
	alignment := #bottom! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignCenter
	
	alignment := #center! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignLeft
	
	alignment := #left! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignRight
	
	alignment := #right! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignTop
	
	alignment := #top! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignment
	
	^alignment! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 10:50'!
alignment: anObject
	
	alignment := anObject! !

!MOAbstractLineLayout methodsFor: 'configuration' stamp: 'Alexandre.Bergel 8/30/2009 11:17'!
center
	self alignment: #center! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
deltaFor: aNodeFigure
	
	^self subclassResponsibility! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: 'Alexandre.Bergel 8/30/2009 10:46'!
doCenter: aGraph
	self subclassResponsibility ! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 2/28/2010 21:47'!
doExecute: aGraph 
	| pointer delta |
	pointer := self positionOriginalPointer: aGraph.
	aGraph nodes do: 
		[ :aNodeFigure | 
		delta := self deltaFor: aNodeFigure.
		aNodeFigure translateTo: pointer - delta.
		self 
			movePointer: pointer
			accordingToFigure: aNodeFigure ].	

	horizontallyStretchable ifTrue: 
		[ self doStretchHorizontal: aGraph ].
	verticallyStretchable ifTrue: 
		[ self doStretchVertical: aGraph ]! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/1/2010 17:57'!
doStretchHorizontal: aGraph 
	"this method is executed after translating nodes"
	
 	| max parentBounds |
	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	max := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: el bounds width ].

	((parentBounds width >= max) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodes do: [ :node | 
						node bounds width: (parentBounds width - (2 * horizontalOutGap)).
						(node layout isLineLayout and: [ node layout horizontallyStretchable ])
							ifTrue: [ node layout doStretchHorizontal: node ]
					] ]
		ifFalse: [ aGraph nodes do: [ :node | node bounds width: max ] ]
	 
! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/1/2010 17:57'!
doStretchVertical: aGraph 
	"this method is executed after translating nodes"

 	| max parentBounds |
	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	max := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: el bounds height ].

	((parentBounds height >= max) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodes do: [ :node | 
						node bounds height: (parentBounds height - (2 * verticalOutGap) ).
						(node layout isLineLayout and: [ node layout verticallyStretchable])
							ifTrue: [ node layout doStretchVertical: node ]
					] ]
		ifFalse: [ aGraph nodes do: [ :node | node bounds height: max ] ]! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
gapSize
	
	^gapSize! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 14:17'!
gapSize: aNumber
	gapSize := aNumber. " This value is never used actually "
	
	verticalGap := 2 * aNumber.
	horizontalGap := 2 * aNumber.
	verticalOutGap := aNumber.
	horizontalOutGap := aNumber! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalGap
	
	^horizontalGap! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalGap: anObject
	
	horizontalGap := anObject! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalOutGap
	
	^horizontalOutGap! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalOutGap: anObject
	
	horizontalOutGap := anObject! !

!MOAbstractLineLayout methodsFor: 'testing' stamp: 'Alexandre Bergel 2/23/2010 18:58'!
horizontallyStretchable
	^ horizontallyStretchable! !

!MOAbstractLineLayout methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 1/6/2010 17:01'!
initialize
	
	super initialize.
	verticalGap := 10.
	horizontalGap := 10.
	horizontalOutGap := 5.
	verticalOutGap := 5.
	horizontallyStretchable := verticallyStretchable := false! !

!MOAbstractLineLayout methodsFor: 'testing' stamp: 'Alexandre Bergel 3/1/2010 17:55'!
isLineLayout
	^ true! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
movePointer: pointer accordingToFigure: aNodeFigure
	
	self subclassResponsibility! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
positionOriginalPointer: aGraph
	
	^self subclassResponsibility! !

!MOAbstractLineLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 1/6/2010 17:01'!
stretch
	horizontallyStretchable := verticallyStretchable := true! !

!MOAbstractLineLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 1/6/2010 17:15'!
stretchHorizontally
	horizontallyStretchable := true! !

!MOAbstractLineLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 1/6/2010 17:15'!
stretchVertically
	verticallyStretchable := true! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalGap
	
	^verticalGap! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalGap: anObject
	
	verticalGap := anObject! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalOutGap
	
	^verticalOutGap! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalOutGap: anObject
	
	verticalOutGap := anObject! !

!MOAbstractLineLayout methodsFor: 'testing' stamp: 'Alexandre Bergel 2/23/2010 18:58'!
verticallyStretchable
	^ verticallyStretchable! !

MOAbstractLineLayout subclass: #MOHorizontalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 11:32'!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #bottom ifTrue: [delta := aNodeFigure height].
	self alignment == #center ifTrue: [delta := aNodeFigure height / 2.0].
	^0 @ delta! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'Alexandre.Bergel 4/24/2009 18:34'!
doCenter: aGraph 

 	| midTallest step |
	midTallest := 0.
	midTallest := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds height )].
	midTallest := midTallest / 2.
	aGraph nodes do: [ :node | 
		step := 0@ (midTallest - (node bounds height /2)) asInteger.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 1/7/2010 08:12'!
doExecute: aGraph 
	| pointer delta |
	pointer := self positionOriginalPointer: aGraph.
	horizontallyStretchable ifTrue: 
		[ self doStretchHorizontal: aGraph ].
	aGraph nodes do: 
		[ :aNodeFigure | 
		delta := self deltaFor: aNodeFigure.
		aNodeFigure translateTo: pointer - delta.
		self 
			movePointer: pointer
			accordingToFigure: aNodeFigure ].	

	verticallyStretchable ifTrue: 
		[ self doStretchVertical: aGraph ]! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/18/2011 19:39'!
doStretchHorizontal: aGraph 

 	| parentBounds addedWidth parentBoundsWidth runningIndex newWidth origin |

	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	addedWidth := aGraph nodes 
		inject: 0
		into: [ :m :el | m + el width ].

	parentBoundsWidth := parentBounds width.
	parentBoundsWidth := parentBoundsWidth - ((aGraph nodes size - 1) * horizontalGap) - (2 * horizontalOutGap).
	
	runningIndex := horizontalOutGap.
	((parentBounds width > addedWidth) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodesDo: [ :node | 
						newWidth := (node width * parentBoundsWidth / addedWidth) asInteger.
						origin := node bounds origin.
						node bounds 
								origin: (runningIndex @ origin y) ;
								width: newWidth.
						runningIndex := runningIndex + newWidth + horizontalGap ] ]
! !

!MOHorizontalLineLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	
	super initialize.
	self alignTop! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:06'!
movePointer: pointer accordingToFigure: aNodeFigure
	
	^pointer moX: pointer x + aNodeFigure bounds width + self horizontalGap! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 2/23/2010 19:39'!
positionOriginalPointer: aGraph 
	| maxHeight delta |
	delta := 0.
	self alignment == #bottom ifTrue: 
		[ maxHeight := aGraph nodes maxValue: #height.
		delta := maxHeight ].
	self alignment == #center ifTrue: 
		[ maxHeight := aGraph nodes maxValue: #height.
		delta := maxHeight / 2.0 ].
	^ self horizontalOutGap @ (self verticalOutGap + delta)! !

MOAbstractLineLayout subclass: #MOVerticalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 11:28'!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #right ifTrue: [delta := aNodeFigure width].
	self alignment == #center ifTrue: [delta := aNodeFigure width / 2.0].
	^delta @ 0! !

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'Alexandre.Bergel 4/24/2009 18:35'!
doCenter: aGraph 

 	| midWidest step |
	midWidest := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds width )].
	midWidest := midWidest / 2.
	aGraph nodes do: [ :node | 
		step := (midWidest - (node bounds width /2)) asInteger @ 0.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/18/2011 19:40'!
doStretchVertical: aGraph 

 	| parentBounds addedHeight parentBoundsHeight runningIndex newHeight origin |

	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	addedHeight := aGraph nodes 
		inject: 0
		into: [ :m :el | m + el height ].

	parentBoundsHeight := parentBounds height.
	parentBoundsHeight := parentBoundsHeight - ((aGraph nodes size - 1) * verticalGap) - (2 * verticalOutGap).
	
	runningIndex := verticalOutGap.
	((parentBounds height > addedHeight) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodesDo: [ :node | 
						newHeight := (node height * parentBoundsHeight / addedHeight) asInteger.
						origin := node bounds origin.
						node bounds 
								origin: (origin x @ runningIndex) ;
								height: newHeight.
						runningIndex := runningIndex + newHeight + verticalGap ] ]
! !

!MOVerticalLineLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	
	super initialize.
	self alignLeft! !

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 10:24'!
movePointer: pointer accordingToFigure: aNodeFigure
	
	^pointer setX: pointer x setY: pointer y + aNodeFigure height + self verticalGap! !

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 11:27'!
positionOriginalPointer: aGraph 
	| maxWidth delta |
	delta := 0.
	self alignment == #right ifTrue: 
		[ maxWidth := aGraph nodes maxValue: #width.
		delta := maxWidth ].
	self alignment == #center ifTrue: 
		[ maxWidth := aGraph nodes maxValue: #width.
		delta := maxWidth / 2.0 ].
	^ (self horizontalOutGap + delta) @ self verticalOutGap! !

MOVerticalLineLayout subclass: #MOVerticalLineWithTimelineLayout
	instanceVariableNames: 'timeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOVerticalLineWithTimelineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 10/3/2011 11:03'!
doExecute: aGraph 
	super doExecute: aGraph .
	
	aGraph nodes do: [ :aNode | aNode translateTo: (timeBlock moValue: aNode model) @ (aNode bounds origin y ) ]! !

!MOVerticalLineWithTimelineLayout methodsFor: 'initialize-release' stamp: 'AlexandreBergel 10/3/2011 11:04'!
initialize
	super initialize.
	timeBlock := 0.! !

!MOVerticalLineWithTimelineLayout methodsFor: 'accessing' stamp: 'MirceaLungu 8/18/2010 21:16'!
timeBlock
	^ timeBlock! !

!MOVerticalLineWithTimelineLayout methodsFor: 'accessing' stamp: 'MirceaLungu 8/18/2010 21:16'!
timeBlock: anObject
	timeBlock := anObject! !

MOLayout subclass: #MOCircleLayout
	instanceVariableNames: 'factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOCircleLayout classSide methodsFor: 'instance creation' stamp: 'Alexandre Bergel 12/17/2009 00:00'!
scaleBy: aNumber
	
	^self new scaleBy: aNumber! !

!MOCircleLayout methodsFor: 'hook' stamp: 'AlexandreBergel 2/17/2009 17:11'!
doExecute: aGraph
	
	| angleTemp angle rad center |
	(self affectedNodesOf: aGraph) isEmpty ifTrue: [^self].
	rad := (self affectedNodesOf: aGraph) size * self scaleFactor.
	center := Point x: rad y: rad.
	angleTemp := 2 * Float pi / (self affectedNodesOf: aGraph) size.
	angle := 0.
	(self affectedNodesOf: aGraph)
		do:
			[:each | 
			| point |
			point := center + (Point r: rad theta: angle).
			angle := angle + angleTemp.
			each translateTo: point]! !

!MOCircleLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self scaleBy: 11! !

!MOCircleLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
scaleBy: aNumber
	
	factor := aNumber! !

!MOCircleLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
scaleFactor
	
	^factor! !

MOLayout subclass: #MOFillInFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOFillInFlowLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 1/26/2010 21:30'!
doExecute: aGraph 
	| x y maxLastLineHeight |
	x := 5.
	y := 5.
	maxLastLineHeight := 0.
	aGraph nodes do: 
		[ :aNodeFigure | 
		aNodeFigure translateTo: x @ y.
		x := x + aNodeFigure width + 10.
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > aGraph width ifTrue: 
			[ x := 5.
			y := y + 10 + maxLastLineHeight.
			maxLastLineHeight := 0 ] ]! !

MOLayout subclass: #MOForceBasedLayout
	instanceVariableNames: 'iterations repellingForce attractingForce'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOForceBasedLayout commentStamp: '<historical>' prior: 0!
MOForceBasedLayout represents a force based layout. It is relatively efficient for a small number of nodes. It however badly scales. Use the FADE Layout for a large number of nodes.

Class collaborations
	MOGraphElement MOEdge MOViewRenderer MONode 

Class public API
		#attractingForce:	#doExecute:	#iterations:	#repellingForce:

Testing classes
	MONewFormsBuilderTest 

Instance Variables:
	iterations -- Number of iterations to considers. An integer. Initialized with 300. 
	repellingForce --  repelling forces between nodes. initialized with 10.
	attractingForce --  Attracting force, initialized with 0.02

Comments written by AlexandreBergel on 28 April 2011
!

!MOForceBasedLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 15:47'!
attractingForce: aBlock
	"Attracting force between edges."
	
	attractingForce := aBlock! !

!MOForceBasedLayout methodsFor: 'private' stamp: 'tg 10/5/2008 23:33'!
attractingForceFor: aFigure
	
	^attractingForce moValue: aFigure! !

!MOForceBasedLayout methodsFor: 'hook' stamp: 'AlexandreBergel 1/24/2011 16:14'!
doExecute: graphElement
	| nodes nodeCenterA nodeCenterB deltaX deltaY distance xForces yForces xForce yForce force random edgesIndices nodeCenter nodeRadius nodeRadiusA nodeRadiusB nodeOrigin minX minY delta radial |
	"Start by placing the nodes at random"
	radial := MORadialTreeLayout new.
	radial fromPositions: self fromPositions.
	radial toPositions: self toPositions.
	radial executeOnNode: graphElement.
	self initializeConnectionPositions: graphElement.	"Init variables"
	random := Random new.	"Create array with the node center and radius. Like this we don't need to move the actual nodes"
	nodes := graphElement nodes asArray.
	nodeCenter := Array new: nodes size.
	nodeRadius := Array new: nodes size.
	1 to: nodes size do: [ :index | 
		nodeCenter at: index put: (nodes at: index) center.
		nodeRadius at: index put: (nodes at: index) radius ].	"Create array with the indices of the edge nodes"
	edgesIndices := Array new: self edges size.
	1 to: self edges size do: [ :index | 
		| edge |
		edge := self edges at: index.
		edgesIndices at: index put: (Array with: (nodes indexOf: edge source) with: (nodes indexOf: edge target)) ].
	1 to: (self iterationsFor: graphElement) do: [ :iteration | 
		xForces := (Array new: nodes size) atAllPut: 0.
		yForces := (Array new: nodes size) atAllPut: 0.	"Node forces"
		1 to: nodes size do: [ :i | 
			i + 1 to: nodes size do: [ :j | 
				nodeCenterA := nodeCenter at: i.
				nodeCenterB := nodeCenter at: j.
				deltaX := nodeCenterB x - nodeCenterA x.
				deltaY := nodeCenterB y - nodeCenterA y.
				distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt.
				distance < 0.01
					ifTrue: [ 
						deltaX := random next + 5.
						deltaY := random next + 5.
						distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt ].
				distance < 100
					ifTrue: [ 
						nodeRadiusA := nodeRadius at: i.
						nodeRadiusB := nodeRadius at: j.
						force := (self repellingForceFor: graphElement) * nodeRadiusA * nodeRadiusB / distance / distance.
						xForce := force * deltaX / distance.
						yForce := force * deltaY / distance.
						xForces at: i put: (xForces at: i) - xForce.
						yForces at: i put: (yForces at: i) - yForce.
						xForces at: j put: (xForces at: j) + xForce.
						yForces at: j put: (yForces at: j) + yForce ] ] ].	"Edge forces"
		edgesIndices
			do: [ :indices | 
				nodeCenterA := nodeCenter at: indices first.
				nodeCenterB := nodeCenter at: indices last.
				deltaX := nodeCenterB x - nodeCenterA x.
				deltaY := nodeCenterB y - nodeCenterA y.
				distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt.
				distance < 0.01
					ifTrue: [ 
						deltaX := random next + 5.
						deltaY := random next + 5.
						distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt ].
				distance := distance min: 15.
				force := (self attractingForceFor: graphElement) * distance.
				xForce := force * deltaX / distance.
				yForce := force * deltaY / distance.
				xForces at: indices first put: (xForces at: indices first) + xForce.
				yForces at: indices first put: (yForces at: indices first) + yForce.
				xForces at: indices last put: (xForces at: indices last) - xForce.
				yForces at: indices last put: (yForces at: indices last) - yForce ].	"Move centers"
		1 to: nodes size do: [ :index | 
			deltaX := xForces at: index.
			deltaY := yForces at: index.
			deltaX := deltaX min: 30.
			deltaX := deltaX max: -30.
			deltaY := deltaY min: 30.
			deltaY := deltaY max: -30.
			nodeCenter at: index put: ((nodeCenter at: index) translatedBy: deltaX @ deltaY) ] ].	"Node origins"
	nodeOrigin := Array new: nodes size.
	minX := 10000000.	"minX := Unlimited positive."
	minY := 10000000.	"minY := Unlimited positive."
	1 to: nodes size do: [ :index | 
		| origin node |
		node := nodes at: index.
		origin := (nodeCenter at: index) - ((node width / 2.0) @ (node height / 2.0)).
		nodeOrigin at: index put: origin.
		minX := minX min: origin x.
		minY := minY min: origin y ].	"Move nodes"
	minX := -1 * minX.
	minY := -1 * minY.
	delta := minX @ minY + (5 @ 5).
	1 to: nodes size do: [ :index | (nodes at: index) translateTo: (nodeOrigin at: index) + delta ]! !

!MOForceBasedLayout methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 2/2/2009 15:47'!
initialize
	
	super initialize.
	iterations := 300.
	repellingForce := 10.
	attractingForce := 0.02! !

!MOForceBasedLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 15:47'!
iterations: aBlock
	
	iterations := aBlock! !

!MOForceBasedLayout methodsFor: 'private' stamp: 'tg 10/5/2008 23:33'!
iterationsFor: aFigure
	
	^iterations moValue: aFigure! !

!MOForceBasedLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 15:48'!
repellingForce: aBlock
	"Repelling force between nodes."
	
	repellingForce := aBlock! !

!MOForceBasedLayout methodsFor: 'private' stamp: 'tg 10/5/2008 23:33'!
repellingForceFor: aFigure
	
	^repellingForce moValue: aFigure! !

MOLayout subclass: #MOGridLayout
	instanceVariableNames: 'gapSize lineItemsCountBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOGridLayout classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 5/4/2011 14:39'!
new
	
	^self withGap: 5! !

!MOGridLayout classSide methodsFor: 'instance creation' stamp: 'tg 4/24/2008 16:08'!
withGap: anInteger 
	^ self 
		withGap: anInteger
		withLineItemsCount: 
			[ :graph | 
			| height width |
			(graph nodes size < 3 
				ifTrue: [ (graph nodes size max: 1) @ 1 ]
				ifFalse: 
					[ height := (graph nodes size * 0.618034) sqrt ceiling truncated.
					width := (graph nodes size / height) ceiling truncated.
					width @ height ]) x ]! !

!MOGridLayout classSide methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withGap: anInteger withLineItemsCount: aBlock
	
	^(super new)
		gapSize: anInteger;
		lineItemsCount: aBlock;
		yourself! !

!MOGridLayout classSide methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withLineItemsCount: aBlock
	
	^(super new)
		gapSize: 2;
		lineItemsCount: aBlock;
		yourself! !

!MOGridLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 10:19'!
doExecute: aGraph 
	| pointer lineItemCount lineItemSize maxLastLineHeight |
	pointer := self gapSize @ self gapSize.
	lineItemSize := self lineItemsCountBlock value: aGraph.
	lineItemCount := 0.
	maxLastLineHeight := 0.
	aGraph nodes do: 
		[ :aNodeFigure | 
		aNodeFigure translateTo: pointer.
		pointer := (pointer x + aNodeFigure width + (self gapSize * 2)) @ pointer y.
		lineItemCount := lineItemCount + 1.
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		lineItemCount >= lineItemSize ifTrue: 
			[ pointer := self gapSize @ (pointer y + (self gapSize * 2) + maxLastLineHeight).
			maxLastLineHeight := 0.
			lineItemCount := 0 ] ]! !

!MOGridLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
gapSize
	
	^gapSize! !

!MOGridLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/10/2009 12:40'!
gapSize: anObject
	
	gapSize := anObject! !

!MOGridLayout methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 2/10/2009 12:40'!
initialize
	
	super initialize.
	gapSize := 5! !

!MOGridLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/10/2009 12:41'!
lineItemsCount: aBlock
	
	lineItemsCountBlock := aBlock! !

!MOGridLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/10/2009 12:41'!
lineItemsCountBlock
	
	^ lineItemsCountBlock! !

MOLayout subclass: #MOMinimumGridLayout
	instanceVariableNames: 'horizontalMode gapSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOMinimumGridLayout classSide methodsFor: 'instance creation' stamp: 'JeanRemyFalleri 6/10/2010 13:27'!
new
	
	^self withGap: 5! !

!MOMinimumGridLayout classSide methodsFor: 'instance creation' stamp: 'JeanRemyFalleri 6/10/2010 15:15'!
withGap: anInteger 

	^(super new) gapSize: anInteger ; yourself.! !

!MOMinimumGridLayout methodsFor: 'accessing' stamp: 'simon.denier 7/7/2010 11:08'!
beHorizontal

	horizontalMode := true! !

!MOMinimumGridLayout methodsFor: 'accessing' stamp: 'simon.denier 7/7/2010 11:08'!
beVertical

	horizontalMode := false! !

!MOMinimumGridLayout methodsFor: 'hook' stamp: 'simon.denier 7/7/2010 11:09'!
doExecute: aGraph 

	horizontalMode
		ifTrue: [ self doHorizontalLayout: aGraph ]
		ifFalse: [ self doVerticalLayout: aGraph ]! !

!MOMinimumGridLayout methodsFor: 'hook' stamp: 'simondenier 7/19/2011 19:12'!
doHorizontalLayout: aGraph 
	| pointer sortedNodes newColumn columnMaxHeight columnMaxWidth h |
	
	sortedNodes := aGraph nodes sorted: [ :a :b | 
		(a height > b height) or: 
		[ (a height = b height) & (a width >= b width) ] ].
	
	pointer := 0 @ 0.
	
	columnMaxWidth := 0.
	columnMaxHeight := sortedNodes first height.
	
	newColumn := true.
	h := 0.
	
	[ sortedNodes isEmpty ] whileFalse: [ | next |
		newColumn ifTrue: [
			pointer := (pointer x + columnMaxWidth + (self gapSize * 2)) @ self gapSize.
			columnMaxWidth := sortedNodes first width.
			h := columnMaxHeight.
			newColumn := false.
		].
	
		next := self nextFit: sortedNodes toHeight: h andWidth: columnMaxWidth.
		
		next isNil
			ifTrue:  [
				newColumn := true ]
			ifFalse: [
				next translateTo: pointer.
				pointer := pointer x @ (pointer y + next height + (2 * self gapSize)).
				h := h - next height ]
	].! !

!MOMinimumGridLayout methodsFor: 'hook' stamp: 'simondenier 7/19/2011 19:12'!
doVerticalLayout: aGraph 
	| pointer sortedNodes newRow columnMaxHeight columnMaxWidth w |
	
	sortedNodes := aGraph nodes sorted: [ :a :b | 
		(a width > b width) or:
		[ (a width = b width) & (a height >= b height) ]].
	
	pointer := 0 @ 0.
	
	columnMaxWidth := sortedNodes first width.
	columnMaxHeight := 0.
	
	newRow := true.
	w := 0.
	
	[ sortedNodes isEmpty ] whileFalse: [ | next |
		newRow ifTrue: [
			pointer := self gapSize @ (pointer y + columnMaxHeight + (self gapSize * 2)).
			columnMaxHeight := sortedNodes first height.
			w := columnMaxWidth .
			newRow := false ].
	
		next := self nextFit: sortedNodes toHeight: columnMaxHeight andWidth: w.
		
		next isNil
			ifTrue:  [
				newRow := true ]
			ifFalse: [
				next translateTo: pointer.
				pointer := (pointer x + next width + (2 * self gapSize)) @ pointer y.
				w := w - next width ]
	].! !

!MOMinimumGridLayout methodsFor: 'testing' stamp: 'JeanRemyFalleri 6/10/2010 17:02'!
fit: aNode inWidth: aWidth andHeight: aHeight

	^( aNode width <= aWidth) & (aNode height <= aHeight ).
	 ! !

!MOMinimumGridLayout methodsFor: 'accessing' stamp: 'JeanRemyFalleri 6/10/2010 13:27'!
gapSize
	
	^gapSize! !

!MOMinimumGridLayout methodsFor: 'accessing' stamp: 'JeanRemyFalleri 6/10/2010 13:27'!
gapSize: anObject
	
	gapSize := anObject! !

!MOMinimumGridLayout methodsFor: 'initialize-release' stamp: 'simon.denier 7/7/2010 11:07'!
initialize
	
	super initialize.
	horizontalMode := true.
	gapSize := 5! !

!MOMinimumGridLayout methodsFor: 'action' stamp: 'AlexandreBergel 1/20/2011 11:03'!
nextFit: aNodeList toHeight: aHeight andWidth: aWidth
	
	1 to: aNodeList size do: [ :index |
		| node |
		node := aNodeList at: index.
		( self fit: node inWidth: aWidth andHeight: aHeight  ) ifTrue: [
			^ aNodeList removeAt: index.
		].
	].
	^nil.

	! !

!MOMinimumGridLayout methodsFor: 'accessing-computed' stamp: 'JeanRemyFalleri 6/10/2010 15:37'!
surface: aNode

	^aNode height * aNode width! !

MOLayout subclass: #MOScatterplotLayout
	instanceVariableNames: 'horizontalPadding verticalPadding xBlock yBlock xOffset yOffset upSideDown scaleFactorX scaleFactorY scaledToWidth scaledToHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOScatterplotLayout methodsFor: 'adjusting' stamp: ' 24/4/08 15:59'!
defaultAdjustHeightFor: childrenBounds and: myBounds
	
	| deltaY |
	deltaY := childrenBounds top - myBounds top.
	^childrenBounds height + deltaY + self yOutGap! !

!MOScatterplotLayout methodsFor: 'adjusting' stamp: ' 24/4/08 15:59'!
defaultAdjustWidthFor: childrenBounds and: myBounds
	
	| deltaX |
	deltaX := childrenBounds left - myBounds left.
	^childrenBounds width + deltaX + self xOutGap! !

!MOScatterplotLayout methodsFor: 'hook' stamp: 'AlexandreBergel 9/6/2010 18:43'!
doExecute: aGraphElement

	| maxWidth maxHeight nodesToLayout x y origin newX newY |
	maxWidth := 0.
	maxHeight := 0.
	nodesToLayout := affectedNodes ifNil: [ aGraphElement nodes ] ifNotNil: [ :arg | affectedNodes ].
	nodesToLayout
		do: [ :node | 
			x := (xBlock value: node model) * scaleFactorX.
			y := (yBlock value: node model) * scaleFactorY.
			maxWidth := maxWidth max: x.
			maxHeight := maxHeight max: y.	"x = #centered ifTrue: [ x := 0 ]."
			x := x + xOffset.
			y := upSideDown
				ifTrue: [ y - yOffset ]
				ifFalse: [ y + yOffset ].
			node translateTo: x @ y ].	"We scale them to the width and height"
	aGraphElement
		nodesDo: [ :node | 
			origin := node bounds origin.
			newX := origin x.
			newY := origin y.
			scaledToWidth ifNotNil: [ :arg | newX := (origin x / maxWidth * scaledToWidth) asInteger ].
			scaledToHeight ifNotNil: [ :arg | newY := (origin y / maxHeight * scaledToHeight) asInteger ].
			node translateTo: newX @ newY ].
	scaledToHeight ifNotNil: [ :arg | maxHeight := scaledToHeight ].
	upSideDown
		ifFalse: [ ^ self ].	"We need to inverse the plots"
	nodesToLayout
		do: [ :node | 
			y := node bounds origin y.
			node translateBy: 0 @ (maxHeight - (2 * y)) ]! !

!MOScatterplotLayout methodsFor: 'hook' stamp: 'Alexandre.Bergel 4/29/2009 15:56'!
doPostOnGraph: aFigure 
	^ super doPostOnGraph: aFigure.
	

	"Position the centered nodes"
"	| x y |
	aFigure nodes do: 
		[ :node | 
		x := node preferredX.
		y := node preferredY.
		x = #centered ifTrue: 
			[ x := aFigure childArea width / 2.0 - (node width / 2.0).
			x := x + node xOffset.
			node translateTo: x @ y ] ]"! !

!MOScatterplotLayout methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 10/14/2009 17:56'!
initialize
	super initialize.

	horizontalPadding := 5.
	verticalPadding := 5.
	xOffset := 0.
	yOffset := 0.
	scaleFactorX := 1.
	scaleFactorY := 1.
	upSideDown := false.
	xBlock := yBlock := [:aNode | aNode ]! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'JeanRemyFalleri 7/13/2010 14:51'!
offset: anInt

	xOffset := anInt.
	yOffset := anInt.! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:57'!
outGap
	
	^ self xOutGap @ self yOutGap! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
outGap: anObject
	
	self xOutGap: anObject.
	self yOutGap: anObject! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 10/14/2009 17:56'!
scaleFactor: aValue
	scaleFactorX := aValue.
	scaleFactorY := aValue! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 10/14/2009 17:57'!
scaleFactorX: aValue
	scaleFactorX := aValue.! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 10/14/2009 17:57'!
scaleFactorY: aValue
	scaleFactorY := aValue.! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:11'!
scaledToHeight
	^ scaledToHeight! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:11'!
scaledToHeight: anObject
	scaledToHeight := anObject! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:12'!
scaledToWidth
	^ scaledToWidth! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:12'!
scaledToWidth: anObject
	scaledToWidth := anObject! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/29/2009 15:46'!
upSideDown
	upSideDown := upSideDown not! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/29/2009 15:34'!
x: aBlock
	xBlock := aBlock! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
xOutGap
	
	^horizontalPadding! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
xOutGap: anObject
	
	horizontalPadding := anObject! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/29/2009 15:35'!
y: aBlock
	yBlock := aBlock! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
yOutGap
	
	^verticalPadding! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
yOutGap: anObject
	
	verticalPadding := anObject! !

MOLayout subclass: #MOSpringLayout
	instanceVariableNames: 'maxSecondsToCompute mass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOSpringLayout commentStamp: 'Alexandre Bergel 3/15/2010 12:58' prior: 0!
Based on the algorithm described on http://en.wikipedia.org/wiki/Force-based_algorithms!

!MOSpringLayout methodsFor: 'physic' stamp: 'Alexandre Bergel 4/2/2010 18:42'!
coulombRepulsion: node and: otherNode
	"mass of node times mass of other Nodes, divided by their squared distance"
	| d v |
	v := node position - otherNode position.
	d := v r.
	d = 0.0 ifTrue: [ ^ v * 15 / (1) ].
	^ v * self mass / (d  * d * d)
	"^ 15 / (d * d)"! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 3/15/2010 14:46'!
damping
	^ 0.5! !

!MOSpringLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/31/2010 18:51'!
doExecute: aGraphElement
	| firstTotalKineticEnergy totalKineticEnergy initialTime |
	firstTotalKineticEnergy := self doIncrementalStep: aGraphElement.
	
	initialTime := Time now asSeconds.
	UIManager default
		displayProgress: 'Layouting'
		at: Sensor cursorPoint
		from: self lowThresholdEnergy 
		to: (firstTotalKineticEnergy r asInteger)
		during: [ :bar | [ totalKineticEnergy := self doIncrementalStep: aGraphElement.
								((Time now asSeconds - initialTime) > self maxSecondsToCompute)
									ifTrue: [ ^ self ].
								bar value: (firstTotalKineticEnergy - totalKineticEnergy) r ] 
								doWhileTrue:  [ (totalKineticEnergy r >= self lowThresholdEnergy) or:
														[ (Time now asSeconds - initialTime) > self maxSecondsToCompute] ]].


! !

!MOSpringLayout methodsFor: 'hook' stamp: 'AlexandreBergel 9/16/2010 01:43'!
doIncrementalStep: aGraphElement
	"Return the total energy "

	| totalKineticEnergy netForce velocity nodesToLayout |
	totalKineticEnergy := 0 @ 0.
	nodesToLayout := affectedNodes ifNil: [ aGraphElement nodes ] ifNotNil: [ affectedNodes ].
	
	nodesToLayout do: [ :node |
		"running sum of total force on this particular node"
		netForce := 0@0.
		nodesToLayout do: [ :otherNode |
			(node ~~ otherNode)
				ifTrue: [ netForce := netForce + (self coulombRepulsion: node and: otherNode) ] ].

		node incomingAndOutgoingEdgesDo: [ :edge |
			(nodesToLayout includesAll: { edge source . edge target}) 
				ifTrue: 
					[ netForce := netForce + (self hookeAttractionFor: node and: edge).]].
				
		velocity := ((node attributeAt: #velocity ifAbsentPut: [0]) +  netForce) * self damping.
		node attributeAt: #velocity put: velocity.
		(((node position + velocity) x > 0) and: [(node position + velocity) y > 0])
			ifTrue: [  (node isSelected and: [ (node hasAttribute: #fixed) not ]) ifFalse: [ node translateBy: velocity  ]].

		"We may need to multiply by the node mass"
		totalKineticEnergy := totalKineticEnergy +  (velocity * velocity). 
	].

	^ totalKineticEnergy! !

!MOSpringLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/21/2010 12:53'!
doIncrementallyExecute: anElementNode
	"called by refreshLayoutEvery: ms. It is used to convey a feeling of incremental execution."
	
	self doIncrementalStep: anElementNode! !

!MOSpringLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 4/2/2010 18:38'!
doInitialize: aGraphElement
	
	| runningPosition nodesToLayout |
	runningPosition := 20@20.
	nodesToLayout := affectedNodes ifNil: [ aGraphElement nodes ] ifNotNil: [ affectedNodes ].
	nodesToLayout do: [ :node | 
		node attributeAt: #velocity put: 0@0.
		
		"make sure no 2 nodes are in exactly the same position"
		node translateTo: runningPosition.
		runningPosition := runningPosition + (10@12) ].
	! !

!MOSpringLayout methodsFor: 'physic' stamp: 'Alexandre Bergel 3/15/2010 18:11'!
hookeAttractionFor: node and: edge
	| f r v vector |
	r := edge length.
	r = 0.0 ifTrue: [ ^ 1@1 ].
	f := 30.
	vector := (edge target position - edge source position) / r.
	v := vector * r  / f.
	^ edge source == node
		ifTrue: [ v ]
		ifFalse: [ v negated ]
! !

!MOSpringLayout methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 4/2/2010 18:42'!
initialize
	super initialize.
	maxSecondsToCompute := 10.
	mass := 1500! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 4/2/2010 09:26'!
lowThresholdEnergy
	^ 2! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 4/2/2010 18:42'!
mass
	^ mass! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 4/2/2010 18:42'!
mass: aValue
	mass := aValue! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 3/31/2010 18:52'!
maxSecondsToCompute
	^ maxSecondsToCompute! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'AlexandreBergel 9/16/2010 01:54'!
maxSecondsToCompute: v
	maxSecondsToCompute := v! !

!Point class methodsFor: '*mondrian-layouts' stamp: 'lr 9/22/2006 14:04'!
r: radius theta: angle
	^ (radius * angle cos) @ (radius * angle sin)! !

TestCase subclass: #MOTreeMapLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts-Tests'!

!SequenceableCollection methodsFor: '*mondrian-layouts' stamp: 'AlexandreBergel 12/29/2010 19:13'!
swapElement: u withElement: v
	| index1 index2 |
	index1 := self indexOf: u.
	index2 := self indexOf: v.
	self at: index2 put: u.
	self at: index1 put: v.! !

Object subclass: #MODummyNode
	instanceVariableNames: 'edge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MODummyNode classSide methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
on: anEdge slot: anIndex
	
	^(self new)
		edge: anEdge;
		slot: anIndex;
		yourself! !

!MODummyNode methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
edge
	
	^edge! !

!MODummyNode methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
edge: anEdge
	
	edge := anEdge! !

!MODummyNode methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
height
	
	^0! !

!MODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/18/2011 16:06'!
slot: anIndex
	! !

!MODummyNode methodsFor: 'accessing' stamp: 'simon.denier 4/30/2009 14:07'!
translateTo: aPoint
	
	"edge index: index point: aPoint"! !

!MODummyNode methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
width
	
	^0! !

Object subclass: #MOIdentityMatrix
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOIdentityMatrix methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
at: u
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row keys! !

!MOIdentityMatrix methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
at: u at: v
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row
		at: v
		ifAbsent: [false]! !

!MOIdentityMatrix methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
at: u at: v put: aBoolean
	
	| row |
	"u -> v"
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	row at: v put: aBoolean.	"v -> u"
	row := rows
		at: v
		ifAbsentPut: [IdentityDictionary new].
	row at: u put: aBoolean! !

!MOIdentityMatrix methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	
	rows := IdentityDictionary new! !

Object subclass: #MOSortBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOSortBlock methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/10/2009 20:21'!
fixTemps! !

!MOSortBlock methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 16:10'!
value: assocA value: assocB
	"Return false if assocA is bigger than assocB.
	Return true if assocA is smaller than assocB.
	-> Inverted list with biggest elements first"
	
	| a b offset |
	offset := 0.
	a := assocA value.
	b := assocB value.
	[(a size > offset)
		and: [(b size > offset) and: [(a at: a size - offset) = (b at: b size - offset)]]]
		whileTrue: [offset := offset + 1].	"Corner cases"
	(a size = b size and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3], [3, 3]"
	(a size > offset and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3, 6], [3, 3]"
	(b size > offset and: [a size = offset]) ifTrue: [ ^ false ].	"[3, 3], [3, 3, 6]"	"Normal case"
	^(a at: a size - offset) >= (b at: b size - offset)! !

Object subclass: #MOTreeLayerWrapper
	instanceVariableNames: 'figures cachedHeight cachedWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOTreeLayerWrapper commentStamp: '<historical>' prior: 0!
This class holds all figures that belong to the same layer. The class also contains auxiliary information
like width and height of the layer.

Instance Variables:
	cachedHeight	<ArithmeticValue>	The height of the layer
	cachedWidth	<ArithmeticValue>	The widht of the layer
	figures	<Collection of: AtlantisFigure>	All figures that belong to this layer

!

!MOTreeLayerWrapper methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
add: aFigure
	
	figures add: aFigure! !

!MOTreeLayerWrapper methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
do: aBlock
	
	figures do: aBlock! !

!MOTreeLayerWrapper methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
height
	
	cachedHeight isNil
		ifTrue:
			[cachedHeight := 0.
			figures do: [:aFigure | cachedHeight := cachedHeight max: aFigure height]].
	^cachedHeight! !

!MOTreeLayerWrapper methodsFor: 'initialize-release' stamp: 'tg 7/25/2010 14:25'!
initialize
	figures := OrderedCollection new.
	cachedWidth := nil.
	cachedHeight := nil! !

!MOTreeLayerWrapper methodsFor: 'accessing' stamp: 'tg 7/25/2010 14:23'!
width: gapSize	
	^ cachedWidth ifNil: [
		cachedWidth := 0.
		figures do: [ :aFigure | cachedWidth := cachedWidth + aFigure width].
		cachedWidth := cachedWidth + ((figures size - 1) * gapSize) ].! !
